rankeko/src/Entity/Course.php
<?php

namespace App\Entity;

use App\Repository\CourseRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use ApiPlatform\Core\Annotation\ApiResource;
use Symfony\Component\Serializer\Annotation\Groups;

#[ORM\Entity(repositoryClass: CourseRepository::class)]
#[ApiResource]

class Course
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]

    private $id;

    #[ORM\Column(type: 'integer', nullable: true)]
    private $distance;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $departurePoint;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $arrivalPoint;

    #[ORM\Column(type: 'string', length: 255)]
    private $QRcode;

    #[ORM\Column(type: 'datetime')]
    private $created_at;

    #[ORM\Column(type: 'datetime')]
    private $finished_at;

    #[ORM\ManyToMany(targetEntity: Employee::class, inversedBy: 'courses')]
    private $employe;

    #[ORM\Column(type: 'integer')]
    private $kms;



    public function __construct()
    {
        $this->employe = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDistance(): ?int
    {
        return $this->distance;
    }

    public function setDistance(?int $distance): self
    {
        $this->distance = $distance;

        return $this;
    }

    public function getDeparturePoint(): ?string
    {
        return $this->departurePoint;
    }

    public function setDeparturePoint(?string $departurePoint): self
    {
        $this->departurePoint = $departurePoint;

        return $this;
    }

    public function getArrivalPoint(): ?string
    {
        return $this->arrivalPoint;
    }

    public function setArrivalPoint(?string $arrivalPoint): self
    {
        $this->arrivalPoint = $arrivalPoint;

        return $this;
    }

    public function getQRcode(): ?string
    {
        return $this->QRcode;
    }

    public function setQRcode(string $QRcode): self
    {
        $this->QRcode = $QRcode;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->created_at;
    }

    public function setCreatedAt(\DateTimeInterface $created_at): self
    {
        $this->created_at = $created_at;

        return $this;
    }

    public function getFinishedAt(): ?\DateTimeInterface
    {
        return $this->finished_at;
    }

    public function setFinishedAt(\DateTimeInterface $finished_at): self
    {
        $this->finished_at = $finished_at;

        return $this;
    }


    /**
     * @return Collection|Employee[]
     */
    public function getEmploye(): Collection
    {
        return $this->employe;
    }

    public function addEmploye(Employee $employe): self
    {
        if (!$this->employe->contains($employe)) {
            $this->employe[] = $employe;
        }

        return $this;
    }

    public function removeEmploye(Employee $employe): self
    {
        $this->employe->removeElement($employe);

        return $this;
    }

    public function getKms(): ?int
    {
        return $this->kms;
    }

    public function setKms(int $kms): self
    {
        $this->kms = $kms;

        return $this;
    }
}

rankeko/src/Form/CourseType.php
<?php

namespace App\Form;

use App\Entity\Course;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class CourseType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('distance')
            ->add('departurePoint')
            ->add('arrivalPoint')
            ->add('QRcode')
            ->add('created_at')
            ->add('finished_at')
            ->add('employe')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Course::class,
        ]);
    }
}

rankeko/src/Controller/CourseController.php
<?php

namespace App\Controller;

use App\Entity\Course;
use App\Form\CourseType;
use App\Repository\CourseRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('/course')]
class CourseController extends AbstractController
{
    #[Route('/', name: 'course_index', methods: ['GET'])]
    public function index(CourseRepository $courseRepository): Response
    {
        return $this->render('course/index.html.twig', [
            'courses' => $courseRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'course_new', methods: ['GET', 'POST'])]
    public function new(Request $request, EntityManagerInterface $entityManager): Response
    {
        $course = new Course();
        $form = $this->createForm(CourseType::class, $course);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($course);
            $entityManager->flush();

            return $this->redirectToRoute('course_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('course/new.html.twig', [
            'course' => $course,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'course_show', methods: ['GET'])]
    public function show(Course $course): Response
    {
        return $this->render('course/show.html.twig', [
            'course' => $course,
        ]);
    }

    #[Route('/{id}/edit', name: 'course_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Course $course, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(CourseType::class, $course);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('course_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('course/edit.html.twig', [
            'course' => $course,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'course_delete', methods: ['POST'])]
    public function delete(Request $request, Course $course, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$course->getId(), $request->request->get('_token'))) {
            $entityManager->remove($course);
            $entityManager->flush();
        }

        return $this->redirectToRoute('course_index', [], Response::HTTP_SEE_OTHER);
    }
}

rankeko/templates/course/_delete_form.html.twig
<form method="post" action="{{ path('course_delete', {'id': course.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ course.id) }}">
    <button class="btn">Delete</button>
</form>

rankeko/templates/course/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

rankeko/templates/course/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Course{% endblock %}

{% block body %}
    <h1>Edit Course</h1>

    {{ include('course/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('course_index') }}">back to list</a>

    {{ include('course/_delete_form.html.twig') }}
{% endblock %}

rankeko/templates/course/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Course index{% endblock %}

{% block body %}
    <h1>Course index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Distance</th>
                <th>DeparturePoint</th>
                <th>ArrivalPoint</th>
                <th>QRcode</th>
                <th>Created_at</th>
                <th>Finished_at</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for course in courses %}
            <tr>
                <td>{{ course.id }}</td>
                <td>{{ course.distance }}</td>
                <td>{{ course.departurePoint }}</td>
                <td>{{ course.arrivalPoint }}</td>
                <td>{{ course.QRcode }}</td>
                <td>{{ course.createdAt ? course.createdAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>{{ course.finishedAt ? course.finishedAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>
                    <a href="{{ path('course_show', {'id': course.id}) }}">show</a>
                    <a href="{{ path('course_edit', {'id': course.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="8">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('course_new') }}">Create new</a>
{% endblock %}

rankeko/templates/course/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Course{% endblock %}

{% block body %}
    <h1>Create new Course</h1>

    {{ include('course/_form.html.twig') }}

    <a href="{{ path('course_index') }}">back to list</a>
{% endblock %}

rankeko/templates/course/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Course{% endblock %}

{% block body %}
    <h1>Course</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ course.id }}</td>
            </tr>
            <tr>
                <th>Distance</th>
                <td>{{ course.distance }}</td>
            </tr>
            <tr>
                <th>DeparturePoint</th>
                <td>{{ course.departurePoint }}</td>
            </tr>
            <tr>
                <th>ArrivalPoint</th>
                <td>{{ course.arrivalPoint }}</td>
            </tr>
            <tr>
                <th>QRcode</th>
                <td>{{ course.QRcode }}</td>
            </tr>
            <tr>
                <th>Created_at</th>
                <td>{{ course.createdAt ? course.createdAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
            <tr>
                <th>Finished_at</th>
                <td>{{ course.finishedAt ? course.finishedAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('course_index') }}">back to list</a>

    <a href="{{ path('course_edit', {'id': course.id}) }}">edit</a>

    {{ include('course/_delete_form.html.twig') }}
{% endblock %}